---
title: UI Tour
slug: Tools/Debugger/UI_Tour
tags:
  - Debugger
  - JavaScript
  - Tools
---
<div>{{ToolsSidebar}}</div>

<p>This article is a quick tour of the main sections of the JavaScript Debugger's user interface. The UI is split vertically into three panels</p>

<ul>
 <li><a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_list_pane">Source list pane</a></li>
 <li><a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_pane">Source pane</a></li>
 <li>The contents of the third pane depend on the current state of the debugger and may include the following sections:
  <ul>
   <li><a href="/en-US/docs/Tools/Debugger/UI_Tour#Toolbar">Toolbar</a></li>
   <li>Watch expressions</li>
   <li><a href="/en-US/docs/Tools/Debugger/UI_Tour#Breakpoints_list">Breakpoints</a></li>
   <li><a href="/en-US/docs/Tools/Debugger/UI_Tour#Call_stack">Call stack</a></li>
   <li><a href="/en-US/docs/Tools/Debugger/UI_Tour#Scopes">Scopes</a></li>
   <li>XHR Breakpoints</li>
   <li>Event Listener Breakpoints</li>
   <li>DOM Mutation Breakpoints</li>
  </ul>
 </li>
</ul>

<p><img alt="" src="https://mdn.mozillademos.org/files/16840/debugger_uiTour_01.png" style="border: 1px solid black; display: block; height: 598px; margin-left: auto; margin-right: auto; width: 922px;"></p>

<h2 id="Source_list_pane">Source list pane</h2>

<p>The source list pane lists all the JavaScript source files loaded into the page (<a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers#Debugging_worker_threads">including scripts for active web workers</a>), and enables you to select one to debug. At the top level sources are organized by origin, and under that they're organized by the directory structure from which they are served.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16841/debugger_uiTour_02.png" style="border: 1px solid black; display: block; height: 598px; margin-left: auto; margin-right: auto; width: 922px;"></p>

<p>You can <a href="/en-US/docs/Tools/Debugger/How_to/Search#Searching_for_files">search for a file</a> using <kbd>Ctrl</kbd> + <kbd>P</kbd> (<kbd>Cmd</kbd> + <kbd>P</kbd> on a Mac).</p>

<p>Web Extensions are listed in the Source List pane using the extension's name.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16868/source_list_pane.png" style="border: 1px solid black; display: block; height: 324px; margin: 0px auto; width: 373px;"></p>

<p>There are several context menu options available for individual files and folders or groups; typically viewed by right-clicking on the item.</p>

<p>For files, the following context menu options are available:</p>

<p><img alt="Screenshot showing the context menu options for files in the source list pane" src="https://mdn.mozillademos.org/files/17324/debugger-source-list-cxt-menu.png" style="border-style: solid; border-width: 1px; height: 203px; width: 294px;"></p>

<ul>
 <li><strong>Copy source URI</strong> copies the full identifier of the file to the clipboard.</li>
 <li><strong>Ignore source</strong> causes the debugger to skip the file when "stepping into" functions; this can be helpful for avoiding stepping into libraries used by your code. When a file is ignored, it has a small eye icon next to it in place of its regular icon.</li>
 <li><strong>Download file</strong> opens a file dialog so you can save the file locally.</li>
</ul>

<p>For folders and groups, the following context menu options are available:</p>

<p><img alt="Screenshot showing context menu options for folders in the source list pane" src="https://mdn.mozillademos.org/files/17325/debugger-source-folder-cxt-menu.png" style="border-style: solid; border-width: 1px; height: 194px; width: 510px;"></p>

<ul>
 <li><strong>Collapse all</strong> collapses all subfolders of the item.</li>
 <li><strong>Expand all</strong> expands all subfolders of the item.</li>
 <li><strong>Set directory root</strong> changes the Source List view so that only that item and its children are visible. The name of the selected directory is shown at the top of the Source List pane; clicking this name reverts the pane to showing all source items.</li>
 <li><strong>Ignore</strong> (since Firefox 76)
  <ul>
   <li><strong>Ignore files in this directory</strong> causes all files within the selected directory to be skipped by the debugger. All child files acquired the eye icon, and the folder menu option changes to <strong>Unignore files in this directory</strong>.</li>
   <li><strong>Ignore files outside this directory</strong> causes all files other than those within the selected directory to be skipped by the debugger. All such files acquire the eye icon, and the menu option for that folder changes to <strong>Unignore files outside this directory</strong>.</li>
  </ul>
 </li>
</ul>

<h3 id="Outline_View">Outline View</h3>

<p>The Outline view shows a tree for navigating the currently open file. Use it to jump directly to a function, class or method definition.</p>

<h2 id="Source_pane">Source pane</h2>

<p>This shows the JavaScript file currently loaded.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16843/debugger_uiTour_02.5.png" style="border: 1px solid black; display: block; height: 598px; margin-left: auto; margin-right: auto; width: 922px;">When the source pane is focused you can <a href="/en-US/docs/Tools/Debugger/How_to/Search#Searching_within_a_file">search for a string in the file</a> using <kbd>Ctrl</kbd> + <kbd>F</kbd> (<kbd>Cmd</kbd> + <kbd>F</kbd> on a Mac).</p>

<p><a href="/en-US/docs/Tools/Debugger/How_to/Set_a_breakpoint">Breakpoints</a> have a blue arrow overlaid on the line number. <a href="/en-US/docs/Tools/Debugger/How_to/Set_a_conditional_breakpoint">Conditional breakpoints</a> have an orange arrow. If you're stopped at a breakpoint, the entire line gets a green overlay. In the screenshot below there are three breakpoints:</p>

<ul>
 <li>line 82 has a normal breakpoint and execution is paused here</li>
 <li>line 85 has a logpoint which logs the contents of tablerow to the console</li>
 <li>line 100 has a conditional breakpoint</li>
</ul>

<p><img alt="" src="https://mdn.mozillademos.org/files/16842/debugger_uiTour_03.png" style="border: 1px solid black; display: block; height: 445px; margin-left: auto; margin-right: auto; width: 922px;"></p>

<p>The third column shows more information about the breakpoints. For example, the logpoint at line 85 logs the value of the tableRow variable to the console and the conditional breakpoint at line 100 breaks if the contents of the todoList is undefined.</p>

<p>The source pane provides the following context menu options:</p>

<p><img alt="Debugger Source Pane Context Menu v2" src="https://mdn.mozillademos.org/files/17412/firefox_source_pane_context_menu.jpg" style="height: 463px; width: 658px;"></p>

<ul>
 <li><strong>Jump to generated location</strong> is used when you have a sourcemap in a project and are currently viewing the original file. Selecting it takes you to the generated file where the selected item was placed.</li>
 <li><strong>Continue to here</strong> causes the debugger to continue execution to the currently selected line (execution will stop before it gets there if there is a breakpoint "on the way").</li>
 <li><strong>Copy to clipboard</strong> copies selected text in the pane into the system clipboard.</li>
 <li><strong>Copy source text</strong> copies all text in the file into the clipboard.</li>
 <li><strong>Copy source URI</strong> copies the file location into the clipboard.</li>
 <li><strong>Download file</strong> opens a file dialog so you can save the file locally.</li>
 <li><strong>Reveal in tree</strong> highlights the file in the source pane list hierarchy.</li>
 <li><strong>Ignore source</strong> causes the debugger to skip the file when "stepping into" functions; this can be helpful for avoiding stepping into libraries used by your code.</li>
 <li><strong>Show inline preview</strong> toggles the inline preview feature, which displays the value of the variable right next to the source when execution is paused.</li>
 <li><strong>Wrap lines</strong>/<strong>Unwap lines</strong> toggles the wrapping of long lines in the pane.</li>
</ul>

<h2 id="Toolbar"><a name="toolbar">Toolbar</a></h2>

<p>At the top of the right-hand pane, there's a toolbar:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/17413/debugger_toolbar_with_settings_menu_four_items.jpg" style="height: 253px; width: 373px;"></p>

<p>The toolbar consists of:</p>

<ul>
 <li>Four buttons to <a href="/en-US/docs/Tools/Debugger/How_to/Step_through_code">control the debugger's movement through the script</a>:

  <ul>
   <li><strong>Play/pause</strong> (<kbd>F8</kbd>): pauses or resumes execution of the script you're debugging. When it displays a "play" icon, that means the script is paused, either because you've paused it with this button or because you've hit a breakpoint.</li>
   <li><strong>Step over</strong> (<kbd>F10</kbd>): steps to the next line of JavaScript code.</li>
   <li><strong>Step in</strong> (<kbd>F11</kbd>): steps into the function call on the current line of JavaScript code.</li>
   <li><strong>Step out</strong> (<kbd>Shift</kbd>-<kbd>F11</kbd>): runs the script until the current function exits.</li>
  </ul>
 </li>
 <li>A button that deactivates all breakpoints.</li>
 <li>A settings menu that contains:
  <ul>
   <li><strong>Disable JavaScript</strong>: disables JavaScript for this tab. This option enables you to see how your web page looks if the user has disabled JavaScript via an extension or a configuration setting. The setting is reset when the Developer Tools are closed (except in Firefox 77, see {{bug("1640318")}}).</li>
   <li><strong>Inline Variable Preview</strong>: enabled by default, this option displays variable values within the source pane when the debugger is paused.</li>
   <li><strong>Wrap Lines</strong>: Toggles wrapping of long lines in the <a href="#Source_pane">source pane</a>.</li>
   <li><strong>Source Maps</strong>: enabled by default, this option directs the Debugger to load the original versions of files, and map them to the generated ones loaded in a page, to ease debugging of translformed sources. See <a href="/en-US/docs/Tools/Debugger/How_to/Use_a_source_map">Use a source map</a> for details.</li>
  </ul>
 </li>
</ul>

<h2 id="Breakpoints_list">Breakpoints list</h2>

<p>Under the toolbar, you'll see all the breakpoints you've set. Next to each breakpoint is a checkbox which you can use to <a href="/en-US/docs/Tools/Debugger/How_to/Disable_breakpoints">enable/disable it</a>:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16845/debugger_uiTour_breakpoints.png" style="border: 1px solid black; display: block; height: 445px; margin-left: auto; margin-right: auto; width: 922px;"></p>

<h2 id="Watch_expressions">Watch expressions</h2>

<p>You can add watch expressions in the right pane. They will be evaluated when code execution is paused:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/14845/watch-expressions.png" style="display: block; height: 769px; margin-left: auto; margin-right: auto; width: 504px;"></p>

<h2 id="Variable_tooltip">Variable tooltip</h2>

<p>Hover on a variable show a tooltip with its value inside:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/14851/tooltip-1.gif" style="display: block; height: 522px; margin-left: auto; margin-right: auto; width: 988px;"></p>

<h2 id="Call_stack">Call stack</h2>

<p>The <em>call stack</em> becomes visible when the debugger is paused.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16846/debugger_uiTour_call_stack.png" style="border: 1px solid black; display: block; height: 445px; margin-left: auto; margin-right: auto; width: 922px;"></p>

<p>The stack lists the chain of functions that are waiting to complete, with the frame for the function that was called last at the top (i.e. the most deeply nested function). Selecting a line opens the associated file in the source pane, at the specified location. It also updates the <a href="#Scopes">Scopes</a> section with the variables for that frame/scope.</p>

<div class="notecard note">
<p><strong>Note</strong>: The call stack is a useful tool for tracking execution flow through your application! It allows you to confirm that functions are called in the order you expect, and with sensible variable values.</p>
</div>

<p>Call stack lines for frames in your own code show the function name and the file location in which it was called.</p>

<div class="notecard note">
<p><strong>Note</strong>: If you click <strong>Step over</strong> (<kbd>F10</kbd>) after changing the selected line in the source pane, the debugger executes until reaching the line following the newly-selected line (disregarding whatever line the debugger originally stopped at).</p>
</div>

<p>Lines for JavaScript frameworks/libraries <em>used </em>by your code (React, jQuery, Angular, Webpack, Backbone etc.) are grouped by default, and represented by a framework-specific icon (see the <em>jQuery</em> frame in the screenshot above). Generally you won't want to debug into the code of frameworks or libraries, so grouping these reduces the complexity of the call stack list. You can still expand and inspect the grouped frames if needed, or disable framework grouping using a context menu option: <strong>Disable framework grouping</strong>. <br>
 <br>
 You can also use the context menu to <strong>Ignore source</strong> for a particular line. This will remove the line from the call stack, and the debugger will subsequently skip through any calls into that file. Note that you'll have to use the source pane "eye icon" or source list if you want to <em>Unignore</em> the source later!</p>

<p><img alt='FF Debugger showing callstack with right-menu and marked up unignore/ignore source "eye"' src="https://mdn.mozillademos.org/files/17447/ff_debugger_callstack_ignore_source.png" style="border-style: solid; border-width: 1px;"></p>

<p>Right-/Ctrl- clicking in the call stack pane opens a context menu with the following items:</p>

<ul>
 <li><strong>Restart frame</strong> restarts execution at the beginning of the current frame.</li>
 <li><strong>Enable framework grouping</strong> collects items belonging to a framework into a collapsible group (for example, Webpack in the screenshot immediately above). When grouping is enabled, the menu option changes to <strong>Disable framework grouping</strong>.</li>
 <li><strong>Copy source URI</strong> copies the full identifier of the source file to the clipboard.</li>
 <li><strong>Ignore source</strong> causes the debugger to skip the file when "stepping into" functions. Any stack frames from the ignored source file are hidden in the call stack pane. (To remove this restriction, choose <strong>Unignore source</strong> in the context menu of the Sources list or the Source pane.)</li>
 <li><strong>Copy stack trace</strong> copies all items in the call stack (including their URIs and line number) to the clipboard.</li>
</ul>

<h2 id="Scopes">Scopes</h2>

<p>In the right-hand pane you'll see a label "Scopes" with a disclosure arrow next to it. When the debugger's paused, you'll be able to expand this section to see all objects that are in scope at this point in the program:</p>

<p><img alt="A screenshot of the Debugger, with the Scopes pane highlighted" src="https://mdn.mozillademos.org/files/17300/Debugger_scopes_Fx78.png" style="border: 1px solid black; display: block; height: 438px; margin-left: auto; margin-right: auto; width: 1096px;">Objects are organized by scope: the most local appears first, and the global scope (Window, in the case of page scripts) appears last.</p>

<p>Within the Scopes pane, you can create <a href="/en-US/docs/Tools/Debugger/How_to/Use_watchpoints">watchpoints</a> that pause the debugger when a value is read or assigned.</p>
